export type SubjectHandler<T> = (message: T, error?: {
    message: string;
}) => void;
export type Subscribe<T> = (handler: SubjectHandler<T>) => () => void;
export type Subject<T> = {
    _subscriptionCount: () => number;
    filter: (filter: (message: T) => boolean) => Subject<T>;
    map: <U = T>(mapper: (message: T) => U) => Subject<U>;
    send: (message: T) => void;
    subscribe: Subscribe<T>;
};
export type SubjectConfig = {
    onUnsubscribe?: (remainingSubscriptionCount: number) => void;
};
export declare const createSubject: <T>(config?: SubjectConfig) => Subject<T>;
export declare const isSubject: <T>(object: unknown) => object is Subject<T>;
