/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
/// <reference types="bun-types" />
/// <reference types="bun-types" />
import type { ServerWebSocket } from 'bun';
import { IncomingMessage } from 'node:http';
import { Duplex } from 'node:stream';
import WebSocket from 'ws';
import { IntegroApp } from './client.js';
export type SubscriptionControllerConfig = {
    subscribeKey?: string;
};
export declare const createSubscriptionController: (app: IntegroApp, { subscribeKey }?: SubscriptionControllerConfig) => {
    createWebSocketServer: (request: IncomingMessage, socket: Duplex, head: Buffer) => void;
    handleRequest: (request: Request | IncomingMessage, arg2?: unknown) => Promise<Response>;
    unsubscribeAll: () => void;
    websocketHandlers: {
        close: () => void;
        message: (ws: ServerWebSocket | WebSocket, message: WebSocket.RawData | string) => Promise<void>;
        open: (ws: ServerWebSocket | WebSocket) => void;
    };
};
