import { IntegroApp } from './types/IntegroApp';
import { HandlerContext } from './types/HandlerContext';
declare const _isUnwrappable: unique symbol;
export type WrappedHandler<T extends IntegroApp> = (context: HandlerContext) => T | Promise<T>;
export type Unwrappable<T extends IntegroApp> = WrappedHandler<T> & {
    [_isUnwrappable]: true;
};
export declare const unwrap: <T extends IntegroApp>(handler: WrappedHandler<T>) => Unwrappable<T>;
export declare const isUnwrappable: <T extends IntegroApp>(fn: unknown) => fn is Unwrappable<T>;
export {};
